enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) {
   * ( char * ) VRAM = c ;
}

void printd ( char d ) {
   printc ( d + ( d < 10 ? '0' : '7' ) ) ;
}

void printb ( char b ) {
   printd ( ( b >> 4 ) & 0x0F ) ;
   printd ( b & 0x0F ) ;
}

void printn ( int n ) {
   printb ( n >> 8 ) ;
   printb ( n ) ;
}

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

int fib ( int n ) {
   return n < 1 ? 0 : n - 1 ? fib ( n - 1 ) + fib ( n - 2 ) : 1 ;
}

int n = 16 ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;
   while ( n = n - 1 ) {
      printn ( fib ( n ) ) ;
      printc ( ' ' ) ;
   }
   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}

