enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) {
   * ( char * ) VRAM = c ;
}

void printf ( char * s ) {
   char * p = s ;
   while ( * p ) printc ( * p ++ ) ;
}

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

int i ;

struct node {
   char n ;
   struct node * next ;
} * list , nodes [ 256 ] ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;

   for ( i = 0 ; i < 256 ; i = i + 1 ) nodes [ i ] . n = i ;

   nodes [ 'l' ] . next = & nodes [ 'i' ] ;
   nodes [ 'i' ] . next = & nodes [ 's' ] ;
   nodes [ 's' ] . next = & nodes [ 't' ] ;
   nodes [ 't' ] . next = 0 ;

   list = & nodes [ 'l' ] ;

   while ( list ) {
      printc ( list -> n ) ; printf ( "->" ) ;
      list = list -> next ;
   }

   printf ( "NULL" ) ;

   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}
