enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) `0x2007 .`
void printd ( char d ) `0x0F & # 10 < { '0' ~ '7' } + printc`
void printb ( char b ) `# 4 >> printd printd`
void printn ( int n ) `# 8 >> printb printb`
void prints ( char * s ) `# , ( # , printc 1 + # , ) _`

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

typedef char i8 ;
typedef int i16 ;
typedef i8 string [ 16 ] ;
typedef struct { i16 x , y , z ; } point ;
typedef struct { i8 r , g , b ; } color ;
typedef struct { point p [ 3 ] ; color c ; } triangle ;
typedef struct { triangle t [ 10 ] ; string id ; } model ;

model m0 , m1 ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;

   m0 . t [ 1 ] . p [ 2 ] . y = 123 ;
   m0 . t [ 2 ] . c . g = 456 ;
   m0 . id = "[3D]" ;
   m1 = m0 ;
   printn ( m1 . t [ 1 ] . p [ 2 ] . y ) ;
   printn ( m1 . t [ 2 ] . c . g ) ;
   prints ( m1 . id ) ;

   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}

