enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) {
   * ( char * ) VRAM = c ;
}

void printd ( char d ) {
   printc ( d + ( d < 10 ? '0' : '7' ) ) ;
}

void printb ( char b ) {
   printd ( ( b >> 4 ) & 0x0F ) ;
   printd ( b & 0x0F ) ;
}

void printn ( int n ) {
   printb ( n >> 8 ) ;
   printb ( n ) ;
}

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

void font ( ) ;

int fac ( char n ) {
   return n ? n * fac ( n - 1 ) : 1 ;
}

int n = 9 ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   font ( ) ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;
   while ( n = n - 1 ) {
      printn ( fac ( n ) ) ;
      printc ( ' ' ) ;
   }
   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}

void tile ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ] 8 [ 0 0x2007 . ]`

void font ( ) {
   VRAMADDR ( 0x0300 ) ;

   tile ( 0x38 , 0x4C , 0xC6 , 0xC6 , 0xC6 , 0x64 , 0x38 , 0x00 ) ;
   tile ( 0x18 , 0x38 , 0x18 , 0x18 , 0x18 , 0x18 , 0x7E , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0x0E , 0x3C , 0x78 , 0xE0 , 0xFE , 0x00 ) ;
   tile ( 0x7E , 0x0C , 0x18 , 0x3C , 0x06 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x1C , 0x3C , 0x6C , 0xCC , 0xFE , 0x0C , 0x0C , 0x00 ) ;
   tile ( 0xFC , 0xC0 , 0xFC , 0x06 , 0x06 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x3C , 0x60 , 0xC0 , 0xFC , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0xFE , 0xC6 , 0x0C , 0x18 , 0x30 , 0x30 , 0x30 , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0x7C , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0x7E , 0x06 , 0x0C , 0x78 , 0x00 ) ;

   VRAMADDR ( 0x0410 ) ;

   tile ( 0x38 , 0x6C , 0xC6 , 0xC6 , 0xFE , 0xC6 , 0xC6 , 0x00 ) ;
   tile ( 0xFC , 0xC6 , 0xC6 , 0xFC , 0xC6 , 0xC6 , 0xFC , 0x00 ) ;
   tile ( 0x3C , 0x66 , 0xC0 , 0xC0 , 0xC0 , 0x66 , 0x3C , 0x00 ) ;
   tile ( 0xF8 , 0xCC , 0xC6 , 0xC6 , 0xC6 , 0xCC , 0xF8 , 0x00 ) ;
   tile ( 0xFE , 0xC0 , 0xC0 , 0xFC , 0xC0 , 0xC0 , 0xFE , 0x00 ) ;
   tile ( 0xFE , 0xC0 , 0xC0 , 0xFC , 0xC0 , 0xC0 , 0xC0 , 0x00 ) ;
}
