
include "INCLUDE\6502.inc"

format binary as 'nes'

db "NES", 0x1A
db 1 ; 16K PRG-ROM page count
db 0 ; 8K CHR-ROM page count
db 1 ; ROM Control Byte #1
db 0 ; ROM Control Byte #1
dq 0 ; times 8 db 0

org 0xC000

macro c x { jsr x }
macro j x { jmp x }
;macro z x { beq x }
macro z x {
   bne @f
   jmp x
   @@:
}
macro r { rts }

macro l n {
   dex
   dex
   if n and 0xFF = n shr 8
      lda =(n and 0xFF)
      sta 0,x
      sta 1,x
   else if ((n and 0xFF) - 1) and 0xFF = n shr 8
      ldy =(n and 0xFF)
      sty 0,x
      dey
      sty 1,x
   else if n and 0xFF = ((n shr 8) - 1) and 0xFF
      ldy =(n and 0xFF)
      sty 0,x
      iny
      sty 1,x
   else
      lda =(n and 0xFF)
      sta 0,x
      lda =(n shr 8)
      sta 1,x
   end if
}

macro t s {
   dex
   dex
   lda =(($+11) and 0xFF)
   sta 0,x
   lda =((($+7) shr 8) and 0xFF)
   sta 1,x
   jmp @f
   db s,0
   @@:
}

macro u x {
   if used x
   x:
}
macro e { end if }

macro m x { macro x }


; adc/and/eor/ora/sbc             +/&/^/|/- (Memory with Accumulator)
; asl/lsr/rol/ror                 Shift Left/Right/Rotate Left/Right (Memory or Accumulator)
; bcc/bcs/beq/bne/bmi/bpl/bvc/bvs Branch on Carry Clear/Set/Zero/not Zero...
; bit                             Test Bits in Memory with Accumulator
; brk                             Force Break
; clc/sec                         Clear/Set Carry Flag
; cld/sed                         Clear/Set Decimal Mode
; cli/sei                         Clear/Set interrupt Disable Bit
; clv                             Clear Overflow Flag
; cmp/cpx/cpy                     Compare Memory and Accumulator/X/Y
; dec/dex/dey/inc/inx/iny         Decrement/Increment Memory/X/Y by One
; jmp/jsr                         Jump/Jump Saving Return Address
; lda/ldx/ldy                     Load Accumulator/X/Y with Memory
; nop                             No Operation
; pha/pla/php/plp                 Push/Pop Accumulator/Processor Status
; rti/rts                         Return from Interrupt/Subroutine
; sta/stx/sty                     Store Accumulator/X/Y in Memory
; tax/tay/txa/tya                 Transfer Accumulator to Index X/Y/X/Y to Accumulator
; tsx/txs                         Transfer Stack Pointer to Index X/Index X to Stack Pointer

; x = sp
; 0x000-0x0FF data stack
; 0x100-0x1FF return stack
; 0x200-0x7FF


m @@2D{c @2D}
m @@2B{c @2B}
m @@2A{c @2A}
m @@26{c @26}
m @@5E{c @5E}
m @@7C{c @7C}
m @@3D{c @3D}
m @@3C{c @3C}
m @@3E{c @3E}
m @@5F{
inx
inx
}
m @@23{c @23}
m @@24{c @24}
m @@3F{c @3F}
m @@40{c @40}
m @@21{c @21}
m @@2C{c @2C}
m @@2E{c @2E}
@20:
lda 0,x
bne @f
dec 1,x
@@:
sec
sbc =1
sta 0,x
and 1,x
cmp =0xFF
rts
@5C:
inx
inx
lda 254,x
ora 255,x
rts
nmi:
inc 0x07FF
irq:
rti
startup:
sei
cld
ldx =0xFE
txs
macro f {
   while $ < 0xFFFA
      db 0
   end while
   dw nmi,startup,irq
}
m @@20 { c @20 }
m @@5C { c @5C }
m @@43454C4C{c @43454C4C}
m @@6E6970{c @6E6970}
m @@2F{c @2F}
m @@3C3C{c @3C3C}
m @@3E3E{c @3E3E}
m @@3E3E3E{
@@3E3E
}
m @@696E63{c @696E63}
m @@646563{c @646563}
m @@6F766572{c @6F766572}
m @@3C3D3E{c @3C3D3E}
m @@3C633D3E{c @3C633D3E}
m @@3C6D656D6370793E{c @3C6D656D6370793E}
m @@3C403E{c @3C403E}
m @@3C2B3D3E{c @3C2B3D3E}
m @@3C2D3D3E{c @3C2D3D3E}
m @@3C2A3D3E{c @3C2A3D3E}
m @@3C2F3D3E{c @3C2F3D3E}
m @@3C3C3C3D3E{c @3C3C3C3D3E}
m @@3C3E3E3D3E{c @3C3E3E3D3E}
m @@3C263D3E{c @3C263D3E}
m @@3C5E3D3E{c @3C5E3D3E}
m @@3C7C3D3E{c @3C7C3D3E}
m @@3C2C3E{c @3C2C3E}
m @@3C632B3D3E{c @3C632B3D3E}
m @@3C632D3D3E{c @3C632D3D3E}
m @@3C632A3D3E{c @3C632A3D3E}
m @@3C632F3D3E{c @3C632F3D3E}
m @@3C633C3C3D3E{c @3C633C3C3D3E}
m @@3C633E3E3D3E{c @3C633E3E3D3E}
m @@3C63263D3E{c @3C63263D3E}
m @@3C635E3D3E{c @3C635E3D3E}
m @@3C637C3D3E{c @3C637C3D3E}
m @@3C626F6F6C3E{c @3C626F6F6C3E}
m @@3C5B5D3E{c @3C5B5D3E}
m @@3C692B2B3E{c @3C692B2B3E}
m @@3C692D2D3E{c @3C692D2D3E}
m @@3C632B2B3E{c @3C632B2B3E}
m @@3C632D2D3E{c @3C632D2D3E}
m @@3C2B2B693E{c @3C2B2B693E}
m @@3C2D2D693E{c @3C2D2D693E}
m @@3C2B2B633E{c @3C2B2B633E}
m @@3C2D2D633E{c @3C2D2D633E}
m @@3C2D783E{c @3C2D783E}
m @@3C7E783E{c @3C7E783E}
m @@3C21783E{c @3C21783E}
m @@3C702B2B3E{c @3C702B2B3E}
m @@3C702D2D3E{c @3C702D2D3E}
m @@3C2B2B703E{
@@3C2B3D3E
}
m @@3C2D2D703E{
@@3C2D3D3E
}
m @@3C3D3D3E{c @3C3D3D3E}
m @@3C213D3E{c @3C213D3E}
m @@3C3C3E{c @3C3C3E}
m @@3C3E3E{c @3C3E3E}
m @@3C3E3D3E{c @3C3E3D3E}
m @@3C3C3D3E{c @3C3C3D3E}
m @@3C6C6F63616C3E{c @3C6C6F63616C3E}
m @@3C626173653E{c @3C626173653E}
m @@3C6270783E{c @3C6270783E}
m @@3C62703E{c @3C62703E}
m @@3C6C3E{c @3C6C3E}
m @@3C656E7465723E{c @3C656E7465723E}
m @@3C6C656176653E{c @3C6C656176653E}
m @@3C6C6F63616C733E{
@@3C6C6F63616C3E
@@3C62703E
@@21
@@3C626173653E
@@3C6270783E
@@21
@@3C6C6F63616C3E
@@3C626173653E
@@21
@@3C6C6F63616C3E
@@3C626173653E
@@43454C4C
@@2B
@@21
}
m @@7072696E7463{c @7072696E7463}
m @@7072696E7464{c @7072696E7464}
m @@7072696E7462{c @7072696E7462}
m @@7072696E746E{c @7072696E746E}
m @@7072696E7473{c @7072696E7473}
m @@5652414D41444452{c @5652414D41444452}
m @@5652414D44415441{c @5652414D44415441}
m @@70616C65747465{c @70616C65747465}
m @@7072696E7466{c @7072696E7466}
m @@6D61696E{
l 0x2000
l 0x0000
@@3C633D3E
@@5F
l 0x2001
l 0x0000
@@3C633D3E
@@5F
@@70616C65747465
@@666F6E74
l 0x2040
@@5652414D41444452
t "%c%X, %s%c"
l 0x0048
l 0xE110
t "WORLD"
l 0x0021
l 0x0004
l 0x0006
@@3C656E7465723E
@@7072696E7466
l 0x2000
l 0x0080
@@3C633D3E
@@5F
l 0x2001
l 0x001E
@@3C633D3E
@@5F
c2:
l 0x0001
@@5C
z lE8DC

j c2
lE8DC:
b2:
}
m @@74696C65{c @74696C65}
m @@7370616365{c @7370616365}
m @@666F6E74{c @666F6E74}
@@3C6C6F63616C733E
@@6D61696E
u @2D
sec
lda 2,x
sbc 0,x
sta 2,x
lda 3,x
sbc 1,x
sta 3,x
inx
inx
r
e
u @2B
clc
lda 2,x
adc 0,x
sta 2,x
lda 3,x
adc 1,x
sta 3,x
inx
inx
r
e
u @2A
l 0x0000
@@24
lE8DB:@@20
z lE8DA

clc
lda 4,x
adc 2,x
sta 2,x
lda 5,x
adc 3,x
sta 3,x
j lE8DB
lE8DA:@@5F

@@6E6970
r
e
u @26
lda 0,x
and 2,x
sta 2,x
lda 1,x
and 3,x
sta 3,x
inx
inx
r
e
u @5E
lda 0,x
eor 2,x
sta 2,x
lda 1,x
eor 3,x
sta 3,x
inx
inx
r
e
u @7C
lda 0,x
ora 2,x
sta 2,x
lda 1,x
ora 3,x
sta 3,x
inx
inx
r
e
u @3D
@@2D
ldy =0
lda 0,x
ora 1,x
sty 1,x
bne @f
iny
@@:
sty 0,x
r
e
u @3C
ldy =0
sec
lda 2,x
sbc 0,x
lda 3,x
sbc 1,x
sty 3,x
bvc @f
eor =0x80
@@:
bpl @f
iny
@@:
sty 2,x
inx
inx
r
e
u @3E
@@24
@@3C
r
e
u @23
dex
dex
lda 3,x
sta 1,x
lda 2,x
sta 0,x
r
e
u @24
lda 0,x
ldy 2,x
sty 0,x
sta 2,x
lda 1,x
ldy 3,x
sty 1,x
sta 3,x
r
e
u @3F
txa
asl 0,x
adc 0,x
tay
lda 2,y
sta 0,x
lda 3,y
sta 1,x
r
e
u @40
lda (0,x)
tay
inc 0,x
lda (0,x)
sta 1,x
sty 0,x
r
e
u @21
lda 2,x
sta (0,x)
inc 0,x
lda 3,x
sta (0,x)
inx
inx
inx
inx
r
e
u @2C
lda (0,x)
sta 0,x
lda =0
sta 1,x
r
e
u @2E
lda 2,x
sta (0,x)
inx
inx
inx
inx
r
e
u @43454C4C
l 0x0002
r
e
u @6E6970
@@24
@@5F
r
e
u @2F
r
e
u @3C3C
ldy 0,x
@@:
beq @f
asl 2,x
rol 3,x
dey
jmp @b
@@:
inx
inx
r
e
u @3E3E
ldy 0,x
@@:
beq @f
lda 3,x
bpl @shr
sec
@shr:
ror 3,x
ror 2,x
dey
jmp @b
@@:
inx
inx
r
e
u @696E63
l 0x0001
@@2B
r
e
u @646563
l 0x0001
@@2D
r
e
u @6F766572
l 0x0001
@@3F
r
e
u @3C3D3E
@@24
@@6F766572
@@24
@@21
r
e
u @3C633D3E
@@24
@@6F766572
@@24
@@2E
r
e
u @3C6D656D6370793E
lE8D9:@@20
z lE8D8

@@6F766572
@@6F766572
@@2B
@@2C
@@6F766572
l 0x0004
@@3F
@@2B
@@2E
j lE8D9
lE8D8:@@5F

@@5F
r
e
u @3C403E
@@6F766572
@@40
r
e
u @3C2B3D3E
@@3C403E
@@2B
@@3C3D3E
r
e
u @3C2D3D3E
@@3C403E
@@24
@@2D
@@3C3D3E
r
e
u @3C2A3D3E
@@3C403E
@@2A
@@3C3D3E
r
e
u @3C2F3D3E
@@3C403E
@@24
@@2F
@@3C3D3E
r
e
u @3C3C3C3D3E
@@3C403E
@@24
@@3C3C
@@3C3D3E
r
e
u @3C3E3E3D3E
@@3C403E
@@24
@@3E3E
@@3C3D3E
r
e
u @3C263D3E
@@3C403E
@@26
@@3C3D3E
r
e
u @3C5E3D3E
@@3C403E
@@5E
@@3C3D3E
r
e
u @3C7C3D3E
@@3C403E
@@7C
@@3C3D3E
r
e
u @3C2C3E
@@6F766572
@@2C
r
e
u @3C632B3D3E
@@3C2C3E
@@2B
@@3C633D3E
r
e
u @3C632D3D3E
@@3C2C3E
@@24
@@2D
@@3C633D3E
r
e
u @3C632A3D3E
@@3C2C3E
@@2A
@@3C633D3E
r
e
u @3C632F3D3E
@@3C2C3E
@@24
@@2F
@@3C633D3E
r
e
u @3C633C3C3D3E
@@3C2C3E
@@24
@@3C3C
@@3C633D3E
r
e
u @3C633E3E3D3E
@@3C2C3E
@@24
@@3E3E
@@3C633D3E
r
e
u @3C63263D3E
@@3C2C3E
@@26
@@3C633D3E
r
e
u @3C635E3D3E
@@3C2C3E
@@5E
@@3C633D3E
r
e
u @3C637C3D3E
@@3C2C3E
@@7C
@@3C633D3E
r
e
u @3C626F6F6C3E
@@5C
z lE8D7

l 0x0001
j lE8D6
lE8D7:
l 0x0000
lE8D6:
r
e
u @3C5B5D3E
@@2A
@@2B
r
e
u @3C692B2B3E
@@23
@@40
@@24
@@6F766572
@@696E63
@@24
@@21
r
e
u @3C692D2D3E
@@23
@@40
@@24
@@6F766572
@@646563
@@24
@@21
r
e
u @3C632B2B3E
@@23
@@2C
@@24
@@6F766572
@@696E63
@@24
@@2E
r
e
u @3C632D2D3E
@@23
@@2C
@@24
@@6F766572
@@646563
@@24
@@2E
r
e
u @3C2B2B693E
@@23
@@40
@@696E63
@@6F766572
@@21
@@40
r
e
u @3C2D2D693E
@@23
@@40
@@646563
@@6F766572
@@21
@@40
r
e
u @3C2B2B633E
@@23
@@2C
@@696E63
@@6F766572
@@21
@@2C
r
e
u @3C2D2D633E
@@23
@@2C
@@646563
@@6F766572
@@21
@@2C
r
e
u @3C2D783E
l 0x0000
@@24
@@2D
r
e
u @3C7E783E
l 0xFFFF
@@5E
r
e
u @3C21783E
l 0x0000
@@3D
@@3C626F6F6C3E
r
e
u @3C702B2B3E
@@6F766572
@@40
@@24
@@6F766572
@@2B
l 0x0002
@@3F
@@21
@@6E6970
r
e
u @3C702D2D3E
@@6F766572
@@40
@@24
@@6F766572
@@24
@@2D
l 0x0002
@@3F
@@21
@@6E6970
r
e
u @3C3D3D3E
@@3D
@@3C626F6F6C3E
r
e
u @3C213D3E
@@2D
@@3C626F6F6C3E
r
e
u @3C3C3E
@@3C
@@3C626F6F6C3E
r
e
u @3C3E3E
@@3E
@@3C626F6F6C3E
r
e
u @3C3E3D3E
@@3C
@@3C7E783E
l 0x0001
@@2B
r
e
u @3C3C3D3E
@@3E
@@3C7E783E
l 0x0001
@@2B
r
e
u @3C6C6F63616C3E
l 0x0200
r
e
u @3C626173653E
l 0x0220
r
e
u @3C6270783E
l 0x0240
r
e
u @3C62703E
l 0x0242
r
e
u @3C6C3E
@@3C62703E
@@40
@@2B
r
e
u @3C656E7465723E
@@3C6270783E
@@40
@@40
@@3C62703E
@@21
@@3C6270783E
@@40
@@43454C4C
@@2B
@@3C6270783E
@@21
@@3C62703E
@@40
@@2B
@@3C6270783E
@@40
@@21
r
e
u @3C6C656176653E
@@3C6270783E
@@40
@@43454C4C
@@2D
@@3C6270783E
@@21
@@3C6270783E
@@40
@@43454C4C
@@2D
@@40
@@3C62703E
@@21
r
e
u @7072696E7463
l 0x2007
@@2E
r
e
u @7072696E7464
l 0x000F
@@26
@@23
l 0x000A
@@3C
@@5C
z lE8D5

l 0x0030
j lE8D4
lE8D5:
l 0x0037
lE8D4:
@@2B
@@7072696E7463
r
e
u @7072696E7462
@@23
l 0x0004
@@3E3E
@@7072696E7464
@@7072696E7464
r
e
u @7072696E746E
@@23
l 0x0008
@@3E3E
@@7072696E7462
@@7072696E7462
r
e
u @7072696E7473
@@23
@@2C
lE8D3:@@5C
z lE8D2

@@23
@@2C
@@7072696E7463
l 0x0001
@@2B
@@23
@@2C
j lE8D3
lE8D2:
@@5F
r
e
u @5652414D41444452
l 0x2006
l 0x0001
@@3F
l 0x0008
@@3E3E
@@3C633D3E
@@5F
l 0x2006
l 0x0001
@@3F
@@3C633D3E
@@5F
l 0x2005
l 0x0000
@@3C633D3E
@@5F
l 0x2005
l 0x0000
@@3C633D3E
@@5F
@@5F
r
e
u @5652414D44415441
@@23
lE8D1:@@20
z lE8D0

@@23
l 0x0002
@@2B
@@3F
l 0x2007
@@2E
j lE8D1
lE8D0:@@5F

lE8CF:@@20
z lE8CE

@@6E6970
j lE8CF
lE8CE:@@5F

r
e
u @70616C65747465
l 0x3F00
@@5652414D41444452
l 0x000F
l 0x0030
l 0x000F
l 0x000F
l 0x0004
@@5652414D44415441
r
e
u @7072696E7466
l 0x0000
@@3F
l 0x0001
@@2B
@@3F
l 0x0000
@@3C6C3E
@@21
l 0x0000
l 0x0002
@@3C6C3E
@@21
c0:
l 0x0004
@@3C6C3E
l 0x0000
@@3C6C3E
l 0x0001
@@3C702B2B3E
@@2C
@@3C633D3E
@@5C
z lE8CD

l 0x0004
@@3C6C3E
@@2C
l 0x0025
@@3C3D3D3E
@@5C
z lE8CC

l 0x0000
@@5C
z lE8CB

s1_'c':
l 0x0002
@@3C6C3E
@@3C692B2B3E
l 0x0002
@@3F
@@24
@@2D
l 0x0001
@@2B
@@3F
@@7072696E7463
j b1
s1_'X':
l 0x0002
@@3C6C3E
@@3C692B2B3E
l 0x0002
@@3F
@@24
@@2D
l 0x0001
@@2B
@@3F
@@7072696E746E
j b1
s1_'s':
l 0x0002
@@3C6C3E
@@3C692B2B3E
l 0x0002
@@3F
@@24
@@2D
l 0x0001
@@2B
@@3F
@@7072696E7473
j b1
s1_d:
l 0x0004
@@3C6C3E
@@2C
@@7072696E7463
j b1
lE8CB:
l 0x0004
@@3C6C3E
l 0x0000
@@3C6C3E
l 0x0001
@@3C702B2B3E
@@2C
@@3C633D3E
@@23
l 0x0063
@@2D
c @5C
z s1_'c'
@@23
l 0x0058
@@2D
c @5C
z s1_'X'
@@23
l 0x0073
@@2D
c @5C
z s1_'s'
j s1_d
b1:
@@5F
j lE8CA
lE8CC:
l 0x0004
@@3C6C3E
@@2C
@@7072696E7463
lE8CA:
j c0
lE8CD:
b0:
lE8C9:@@20
z lE8C8

@@6E6970
j lE8C9
lE8C8:@@5F

@@5F
@@3C6C656176653E
r
e
u @74696C65
@@23
lE8C7:@@20
z lE8C6

@@23
l 0x0002
@@2B
@@3F
l 0x2007
@@2E
j lE8C7
lE8C6:@@5F

lE8C5:@@20
z lE8C4

@@6E6970
j lE8C5
lE8C4:@@5F

l 0x0008
lE8C3:@@20
z lE8C2

l 0x0000
l 0x2007
@@2E
j lE8C3
lE8C2:@@5F

r
e
u @7370616365
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
r
e
u @666F6E74
l 0x0000
@@5652414D41444452
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
@@7370616365
l 0x0018
l 0x003C
l 0x003C
l 0x003C
l 0x0018
l 0x0018
l 0x0000
l 0x0018
l 0x0008
@@74696C65
l 0x006C
l 0x006C
l 0x006C
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x006C
l 0x006C
l 0x00FE
l 0x006C
l 0x00FE
l 0x006C
l 0x006C
l 0x0000
l 0x0008
@@74696C65
l 0x0030
l 0x007C
l 0x00C0
l 0x0078
l 0x000C
l 0x00F8
l 0x0030
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x00C6
l 0x00CC
l 0x0018
l 0x0030
l 0x0066
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x0038
l 0x006C
l 0x0038
l 0x0076
l 0x00DC
l 0x00CC
l 0x0076
l 0x0000
l 0x0008
@@74696C65
l 0x0060
l 0x0060
l 0x00C0
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0018
l 0x0030
l 0x0060
l 0x0060
l 0x0060
l 0x0030
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0060
l 0x0030
l 0x0018
l 0x0018
l 0x0018
l 0x0030
l 0x0060
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0066
l 0x003C
l 0x00FF
l 0x003C
l 0x0066
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0030
l 0x0030
l 0x00FC
l 0x0030
l 0x0030
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0030
l 0x0030
l 0x0060
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0000
l 0x00FC
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0030
l 0x0030
l 0x0000
l 0x0008
@@74696C65
l 0x0006
l 0x000C
l 0x0018
l 0x0030
l 0x0060
l 0x00C0
l 0x0080
l 0x0000
l 0x0008
@@74696C65
l 0x0038
l 0x004C
l 0x00C6
l 0x00C6
l 0x00C6
l 0x0064
l 0x0038
l 0x0000
l 0x0008
@@74696C65
l 0x0018
l 0x0038
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x007E
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x000E
l 0x003C
l 0x0078
l 0x00E0
l 0x00FE
l 0x0000
l 0x0008
@@74696C65
l 0x007E
l 0x000C
l 0x0018
l 0x003C
l 0x0006
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x001C
l 0x003C
l 0x006C
l 0x00CC
l 0x00FE
l 0x000C
l 0x000C
l 0x0000
l 0x0008
@@74696C65
l 0x00FC
l 0x00C0
l 0x00FC
l 0x0006
l 0x0006
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x003C
l 0x0060
l 0x00C0
l 0x00FC
l 0x00C6
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x00FE
l 0x00C6
l 0x000C
l 0x0018
l 0x0030
l 0x0030
l 0x0030
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x00C6
l 0x007C
l 0x00C6
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x00C6
l 0x007E
l 0x0006
l 0x000C
l 0x0078
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0030
l 0x0030
l 0x0000
l 0x0000
l 0x0030
l 0x0030
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0030
l 0x0030
l 0x0000
l 0x0000
l 0x0030
l 0x0030
l 0x0060
l 0x0008
@@74696C65
l 0x0018
l 0x0030
l 0x0060
l 0x00C0
l 0x0060
l 0x0030
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x00FC
l 0x0000
l 0x0000
l 0x00FC
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0060
l 0x0030
l 0x0018
l 0x000C
l 0x0018
l 0x0030
l 0x0060
l 0x0000
l 0x0008
@@74696C65
l 0x0078
l 0x00CC
l 0x000C
l 0x0018
l 0x0030
l 0x0000
l 0x0030
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x00DE
l 0x00DE
l 0x00DE
l 0x00C0
l 0x0078
l 0x0000
l 0x0008
@@74696C65
l 0x0038
l 0x006C
l 0x00C6
l 0x00C6
l 0x00FE
l 0x00C6
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x00FC
l 0x00C6
l 0x00C6
l 0x00FC
l 0x00C6
l 0x00C6
l 0x00FC
l 0x0000
l 0x0008
@@74696C65
l 0x003C
l 0x0066
l 0x00C0
l 0x00C0
l 0x00C0
l 0x0066
l 0x003C
l 0x0000
l 0x0008
@@74696C65
l 0x00F8
l 0x00CC
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00CC
l 0x00F8
l 0x0000
l 0x0008
@@74696C65
l 0x00FE
l 0x00C0
l 0x00C0
l 0x00FC
l 0x00C0
l 0x00C0
l 0x00FE
l 0x0000
l 0x0008
@@74696C65
l 0x00FE
l 0x00C0
l 0x00C0
l 0x00FC
l 0x00C0
l 0x00C0
l 0x00C0
l 0x0000
l 0x0008
@@74696C65
l 0x003E
l 0x0060
l 0x00C0
l 0x00CE
l 0x00C6
l 0x0066
l 0x003E
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00FE
l 0x00C6
l 0x00C6
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x007E
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x007E
l 0x0000
l 0x0008
@@74696C65
l 0x001E
l 0x0006
l 0x0006
l 0x0006
l 0x00C6
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00CC
l 0x00D8
l 0x00F0
l 0x00F8
l 0x00DC
l 0x00CE
l 0x0000
l 0x0008
@@74696C65
l 0x0060
l 0x0060
l 0x0060
l 0x0060
l 0x0060
l 0x0060
l 0x007E
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00EE
l 0x00FE
l 0x00FE
l 0x00D6
l 0x00C6
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00E6
l 0x00F6
l 0x00FE
l 0x00DE
l 0x00CE
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x00FC
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00FC
l 0x00C0
l 0x00C0
l 0x0000
l 0x0008
@@74696C65
l 0x007C
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00DE
l 0x00CC
l 0x007A
l 0x0000
l 0x0008
@@74696C65
l 0x00FC
l 0x00C6
l 0x00C6
l 0x00CE
l 0x00F8
l 0x00DC
l 0x00CE
l 0x0000
l 0x0008
@@74696C65
l 0x0078
l 0x00CC
l 0x00C0
l 0x007C
l 0x0006
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x007E
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00C6
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00C6
l 0x00C6
l 0x00EE
l 0x007C
l 0x0038
l 0x0010
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00C6
l 0x00D6
l 0x00FE
l 0x00FE
l 0x00EE
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x00C6
l 0x00EE
l 0x007C
l 0x0038
l 0x007C
l 0x00EE
l 0x00C6
l 0x0000
l 0x0008
@@74696C65
l 0x0066
l 0x0066
l 0x0066
l 0x003C
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x00FE
l 0x000E
l 0x001C
l 0x0038
l 0x0070
l 0x00E0
l 0x00FE
l 0x0000
l 0x0008
@@74696C65
l 0x0078
l 0x0060
l 0x0060
l 0x0060
l 0x0060
l 0x0060
l 0x0078
l 0x0000
l 0x0008
@@74696C65
l 0x00C0
l 0x0060
l 0x0030
l 0x0018
l 0x000C
l 0x0006
l 0x0002
l 0x0000
l 0x0008
@@74696C65
l 0x0078
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0078
l 0x0000
l 0x0008
@@74696C65
l 0x0010
l 0x0038
l 0x006C
l 0x00C6
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x00FF
l 0x0008
@@74696C65
l 0x0030
l 0x0030
l 0x0018
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003C
l 0x0066
l 0x0066
l 0x0066
l 0x003B
l 0x0000
l 0x0008
@@74696C65
l 0x0060
l 0x0060
l 0x007C
l 0x0066
l 0x0066
l 0x0066
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003E
l 0x0060
l 0x0060
l 0x0060
l 0x003E
l 0x0000
l 0x0008
@@74696C65
l 0x0006
l 0x0006
l 0x003E
l 0x0066
l 0x0066
l 0x0066
l 0x003E
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003C
l 0x0066
l 0x007E
l 0x0060
l 0x003E
l 0x0000
l 0x0008
@@74696C65
l 0x000E
l 0x0018
l 0x0018
l 0x007E
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003E
l 0x0066
l 0x0066
l 0x003E
l 0x0006
l 0x003C
l 0x0008
@@74696C65
l 0x0060
l 0x0060
l 0x0060
l 0x007C
l 0x0066
l 0x0066
l 0x0066
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0018
l 0x0000
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0006
l 0x0000
l 0x0006
l 0x0006
l 0x0006
l 0x0066
l 0x003C
l 0x0008
@@74696C65
l 0x0060
l 0x0060
l 0x0062
l 0x0064
l 0x0068
l 0x007C
l 0x0066
l 0x0000
l 0x0008
@@74696C65
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0076
l 0x006B
l 0x006B
l 0x006B
l 0x006B
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x007C
l 0x0066
l 0x0066
l 0x0066
l 0x0066
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003C
l 0x0066
l 0x0066
l 0x0066
l 0x003C
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x007C
l 0x0066
l 0x0066
l 0x007C
l 0x0060
l 0x0060
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003E
l 0x0066
l 0x0066
l 0x003E
l 0x0006
l 0x0006
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x006E
l 0x0070
l 0x0060
l 0x0060
l 0x0060
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x003C
l 0x0040
l 0x003C
l 0x0006
l 0x007C
l 0x0000
l 0x0008
@@74696C65
l 0x0030
l 0x0030
l 0x00FC
l 0x0030
l 0x0030
l 0x0030
l 0x001C
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0066
l 0x0066
l 0x0066
l 0x0066
l 0x003C
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0066
l 0x0066
l 0x0066
l 0x0024
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0063
l 0x006B
l 0x006B
l 0x006B
l 0x0036
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0063
l 0x0036
l 0x001C
l 0x0036
l 0x0063
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x0066
l 0x0066
l 0x002C
l 0x0018
l 0x0030
l 0x0060
l 0x0008
@@74696C65
l 0x0000
l 0x0000
l 0x007E
l 0x000C
l 0x0018
l 0x0030
l 0x007E
l 0x0000
l 0x0008
@@74696C65
l 0x001C
l 0x0030
l 0x0030
l 0x00E0
l 0x0030
l 0x0030
l 0x001C
l 0x0000
l 0x0008
@@74696C65
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0018
l 0x0018
l 0x0018
l 0x0000
l 0x0008
@@74696C65
l 0x00E0
l 0x0030
l 0x0030
l 0x001C
l 0x0030
l 0x0030
l 0x00E0
l 0x0000
l 0x0008
@@74696C65
l 0x0076
l 0x00DC
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0000
l 0x0008
@@74696C65
l 0x0000
l 0x0010
l 0x0038
l 0x006C
l 0x00C6
l 0x00C6
l 0x00FE
l 0x0000
l 0x0008
@@74696C65
r
e
f