enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) {
   * ( char * ) VRAM = c ;
}

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

void font ( ) ;

void f ( int n ) {
   switch ( n ) {
      case 1 : printc ( '1' ) ; break ;
      case 2 : printc ( '2' ) ; break ;
      case 10 : printc ( 'A' ) ; break ;
      default : printc ( '.' ) ;
   }
}

int i ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   font ( ) ;
   VRAMADDR ( 0x2040 ) ;

   for ( i = 0 ; i < 16 ; i ++ ) f ( i ) ;

   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}

void tile ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ] 8 [ 0 0x2007 . ]`

void space ( ) { tile ( 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ) ; }

void font ( ) {
   VRAMADDR ( 0x0000 ) ;

   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;
   space ( ) ;

   space ( ) ;
   tile ( 0x18 , 0x3C , 0x3C , 0x3C , 0x18 , 0x18 , 0x00 , 0x18 ) ;
   tile ( 0x6C , 0x6C , 0x6C , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x6C , 0x6C , 0xFE , 0x6C , 0xFE , 0x6C , 0x6C , 0x00 ) ;
   tile ( 0x30 , 0x7C , 0xC0 , 0x78 , 0x0C , 0xF8 , 0x30 , 0x00 ) ;
   tile ( 0x00 , 0xC6 , 0xCC , 0x18 , 0x30 , 0x66 , 0xC6 , 0x00 ) ;
   tile ( 0x38 , 0x6C , 0x38 , 0x76 , 0xDC , 0xCC , 0x76 , 0x00 ) ;
   tile ( 0x60 , 0x60 , 0xC0 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x18 , 0x30 , 0x60 , 0x60 , 0x60 , 0x30 , 0x18 , 0x00 ) ;
   tile ( 0x60 , 0x30 , 0x18 , 0x18 , 0x18 , 0x30 , 0x60 , 0x00 ) ;
   tile ( 0x00 , 0x66 , 0x3C , 0xFF , 0x3C , 0x66 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x30 , 0x30 , 0xFC , 0x30 , 0x30 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x30 , 0x30 , 0x60 ) ;
   tile ( 0x00 , 0x00 , 0x00 , 0xFC , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x30 , 0x30 , 0x00 ) ;
   tile ( 0x06 , 0x0C , 0x18 , 0x30 , 0x60 , 0xC0 , 0x80 , 0x00 ) ;
   tile ( 0x38 , 0x4C , 0xC6 , 0xC6 , 0xC6 , 0x64 , 0x38 , 0x00 ) ;
   tile ( 0x18 , 0x38 , 0x18 , 0x18 , 0x18 , 0x18 , 0x7E , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0x0E , 0x3C , 0x78 , 0xE0 , 0xFE , 0x00 ) ;
   tile ( 0x7E , 0x0C , 0x18 , 0x3C , 0x06 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x1C , 0x3C , 0x6C , 0xCC , 0xFE , 0x0C , 0x0C , 0x00 ) ;
   tile ( 0xFC , 0xC0 , 0xFC , 0x06 , 0x06 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x3C , 0x60 , 0xC0 , 0xFC , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0xFE , 0xC6 , 0x0C , 0x18 , 0x30 , 0x30 , 0x30 , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0x7C , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0x7E , 0x06 , 0x0C , 0x78 , 0x00 ) ;
   tile ( 0x00 , 0x30 , 0x30 , 0x00 , 0x00 , 0x30 , 0x30 , 0x00 ) ;
   tile ( 0x00 , 0x30 , 0x30 , 0x00 , 0x00 , 0x30 , 0x30 , 0x60 ) ;
   tile ( 0x18 , 0x30 , 0x60 , 0xC0 , 0x60 , 0x30 , 0x18 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0xFC , 0x00 , 0x00 , 0xFC , 0x00 , 0x00 ) ;
   tile ( 0x60 , 0x30 , 0x18 , 0x0C , 0x18 , 0x30 , 0x60 , 0x00 ) ;
   tile ( 0x78 , 0xCC , 0x0C , 0x18 , 0x30 , 0x00 , 0x30 , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xDE , 0xDE , 0xDE , 0xC0 , 0x78 , 0x00 ) ;
   tile ( 0x38 , 0x6C , 0xC6 , 0xC6 , 0xFE , 0xC6 , 0xC6 , 0x00 ) ;
   tile ( 0xFC , 0xC6 , 0xC6 , 0xFC , 0xC6 , 0xC6 , 0xFC , 0x00 ) ;
   tile ( 0x3C , 0x66 , 0xC0 , 0xC0 , 0xC0 , 0x66 , 0x3C , 0x00 ) ;
   tile ( 0xF8 , 0xCC , 0xC6 , 0xC6 , 0xC6 , 0xCC , 0xF8 , 0x00 ) ;
   tile ( 0xFE , 0xC0 , 0xC0 , 0xFC , 0xC0 , 0xC0 , 0xFE , 0x00 ) ;
   tile ( 0xFE , 0xC0 , 0xC0 , 0xFC , 0xC0 , 0xC0 , 0xC0 , 0x00 ) ;
   tile ( 0x3E , 0x60 , 0xC0 , 0xCE , 0xC6 , 0x66 , 0x3E , 0x00 ) ;
   tile ( 0xC6 , 0xC6 , 0xC6 , 0xFE , 0xC6 , 0xC6 , 0xC6 , 0x00 ) ;
   tile ( 0x7E , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x7E , 0x00 ) ;
   tile ( 0x1E , 0x06 , 0x06 , 0x06 , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0xC6 , 0xCC , 0xD8 , 0xF0 , 0xF8 , 0xDC , 0xCE , 0x00 ) ;
   tile ( 0x60 , 0x60 , 0x60 , 0x60 , 0x60 , 0x60 , 0x7E , 0x00 ) ;
   tile ( 0xC6 , 0xEE , 0xFE , 0xFE , 0xD6 , 0xC6 , 0xC6 , 0x00 ) ;
   tile ( 0xC6 , 0xE6 , 0xF6 , 0xFE , 0xDE , 0xCE , 0xC6 , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0xC6 , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0xFC , 0xC6 , 0xC6 , 0xC6 , 0xFC , 0xC0 , 0xC0 , 0x00 ) ;
   tile ( 0x7C , 0xC6 , 0xC6 , 0xC6 , 0xDE , 0xCC , 0x7A , 0x00 ) ;
   tile ( 0xFC , 0xC6 , 0xC6 , 0xCE , 0xF8 , 0xDC , 0xCE , 0x00 ) ;
   tile ( 0x78 , 0xCC , 0xC0 , 0x7C , 0x06 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0x7E , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0xC6 , 0xC6 , 0xC6 , 0xC6 , 0xC6 , 0xC6 , 0x7C , 0x00 ) ;
   tile ( 0xC6 , 0xC6 , 0xC6 , 0xEE , 0x7C , 0x38 , 0x10 , 0x00 ) ;
   tile ( 0xC6 , 0xC6 , 0xD6 , 0xFE , 0xFE , 0xEE , 0xC6 , 0x00 ) ;
   tile ( 0xC6 , 0xEE , 0x7C , 0x38 , 0x7C , 0xEE , 0xC6 , 0x00 ) ;
   tile ( 0x66 , 0x66 , 0x66 , 0x3C , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0xFE , 0x0E , 0x1C , 0x38 , 0x70 , 0xE0 , 0xFE , 0x00 ) ;
   tile ( 0x78 , 0x60 , 0x60 , 0x60 , 0x60 , 0x60 , 0x78 , 0x00 ) ;
   tile ( 0xC0 , 0x60 , 0x30 , 0x18 , 0x0C , 0x06 , 0x02 , 0x00 ) ;
   tile ( 0x78 , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x78 , 0x00 ) ;
   tile ( 0x10 , 0x38 , 0x6C , 0xC6 , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0xFF ) ;
   tile ( 0x30 , 0x30 , 0x18 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3C , 0x66 , 0x66 , 0x66 , 0x3B , 0x00 ) ;
   tile ( 0x60 , 0x60 , 0x7C , 0x66 , 0x66 , 0x66 , 0x7C , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3E , 0x60 , 0x60 , 0x60 , 0x3E , 0x00 ) ;
   tile ( 0x06 , 0x06 , 0x3E , 0x66 , 0x66 , 0x66 , 0x3E , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3C , 0x66 , 0x7E , 0x60 , 0x3E , 0x00 ) ;
   tile ( 0x0E , 0x18 , 0x18 , 0x7E , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3E , 0x66 , 0x66 , 0x3E , 0x06 , 0x3C ) ;
   tile ( 0x60 , 0x60 , 0x60 , 0x7C , 0x66 , 0x66 , 0x66 , 0x00 ) ;
   tile ( 0x00 , 0x18 , 0x00 , 0x18 , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0x00 , 0x06 , 0x00 , 0x06 , 0x06 , 0x06 , 0x66 , 0x3C ) ;
   tile ( 0x60 , 0x60 , 0x62 , 0x64 , 0x68 , 0x7C , 0x66 , 0x00 ) ;
   tile ( 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x76 , 0x6B , 0x6B , 0x6B , 0x6B , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x7C , 0x66 , 0x66 , 0x66 , 0x66 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3C , 0x66 , 0x66 , 0x66 , 0x3C , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x7C , 0x66 , 0x66 , 0x7C , 0x60 , 0x60 ) ;
   tile ( 0x00 , 0x00 , 0x3E , 0x66 , 0x66 , 0x3E , 0x06 , 0x06 ) ;
   tile ( 0x00 , 0x00 , 0x6E , 0x70 , 0x60 , 0x60 , 0x60 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x3C , 0x40 , 0x3C , 0x06 , 0x7C , 0x00 ) ;
   tile ( 0x30 , 0x30 , 0xFC , 0x30 , 0x30 , 0x30 , 0x1C , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x66 , 0x66 , 0x66 , 0x66 , 0x3C , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x66 , 0x66 , 0x66 , 0x24 , 0x18 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x63 , 0x6B , 0x6B , 0x6B , 0x36 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x63 , 0x36 , 0x1C , 0x36 , 0x63 , 0x00 ) ;
   tile ( 0x00 , 0x00 , 0x66 , 0x66 , 0x2C , 0x18 , 0x30 , 0x60 ) ;
   tile ( 0x00 , 0x00 , 0x7E , 0x0C , 0x18 , 0x30 , 0x7E , 0x00 ) ;
   tile ( 0x1C , 0x30 , 0x30 , 0xE0 , 0x30 , 0x30 , 0x1C , 0x00 ) ;
   tile ( 0x18 , 0x18 , 0x18 , 0x00 , 0x18 , 0x18 , 0x18 , 0x00 ) ;
   tile ( 0xE0 , 0x30 , 0x30 , 0x1C , 0x30 , 0x30 , 0xE0 , 0x00 ) ;
   tile ( 0x76 , 0xDC , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 ) ;
   tile ( 0x00 , 0x10 , 0x38 , 0x6C , 0xC6 , 0xC6 , 0xFE , 0x00 ) ;
}
